#include <stdio.h>		//printf()
#include <stdlib.h>		//exit()
#include <signal.h>     //signal()

#include "DEV_Config.h"
#include <time.h>
#include "Waveshare_EMC2301.h"

void  EMC2301_Handler(int signo)
{
    //System Exit
    printf("\r\nHandler:exit\r\n");
    DEV_ModuleExit();

    exit(0);
}

int main(void)
{
    // Exception handling:ctrl + c
    signal(SIGINT, EMC2301_Handler);
    DEV_ModuleInit();
    DEV_I2C_Init(EMC2301_ADDRESS);
	int product_ID = I2C_Read_Byte(PRODUCT_ID);
	int Manufacturer_ID = I2C_Read_Byte(MANUFACTURER_ID);
	//printf("ID_value : %x\r\n",product_ID);
	//printf("Manufacturer_ID: %x\r\n",Manufacturer_ID);
	if(product_ID == 0x37&& Manufacturer_ID==0x5D)
	{
		printf("I2C ok !\r\n");
		EMC2301_start();
	/*********************************/	
		EMC2301_setSpinUpDrive(60);
		EMC2301_setSpinUpTime(300);
		EMC2301_setDriveUpdatePeriod(100);
		EMC2301_RPMEnable();
			
		EMC2301_writeTachoTarget(8192);
		for(int i=0;i<10;i++)
		{
			EMC2301_fetchFanSpeed();
			DEV_Delay_ms(500);
		}
		
		EMC2301_writeTachoTarget(32);
		for(int i=0;i<10;i++)
		{
			EMC2301_fetchFanSpeed();
			DEV_Delay_ms(500);
		}
		
		EMC2301_writeTachoTarget(500);
		for(int i=0;i<10;i++)
		{
			EMC2301_fetchFanSpeed();
			DEV_Delay_ms(500);
		}
		
		EMC2301_writeTachoTarget(1000);
		for(int i=0;i<10;i++)
		{
			EMC2301_fetchFanSpeed();
			DEV_Delay_ms(500);
		}
		
		EMC2301_writeTachoTarget(5000);
		for(int i=0;i<10;i++)
		{
			EMC2301_fetchFanSpeed();
			DEV_Delay_ms(500);
		}
		
		EMC2301_writeTachoTarget(8192);
		for(int i=0;i<10;i++)
		{
			EMC2301_fetchFanSpeed();
			DEV_Delay_ms(500);
		}
		
		EMC2301_writeTachoTarget(32);
		for(int i=0;i<10;i++)
		{
			EMC2301_fetchFanSpeed();
			DEV_Delay_ms(500);
		}
		
		EMC2301_writeTachoTarget(0);
		for(int i=0;i<10;i++)
		{
			EMC2301_fetchFanSpeed();
			DEV_Delay_ms(500);
		}		
		
	/********************************/
	
	//Comment the code above, uncomment the code below, means direct control of the wind speed.
	/********************************/
	    // EMC2301_Directspeedcontrol(120);//0~255
		// for(int i=0;i<12;i++)
		// {
			// EMC2301_fetchFanSpeed();
			// DEV_Delay_ms(500);
		// }
	/********************************/
	
	}
	else
	{
		printf("I2C Error !");
	}
	

	//System Exit
	DEV_ModuleExit();
	return 0;
	
}

