import time
import sys
import os

libdir = os.path.join(os.path.dirname(os.path.dirname(os.path.realpath(__file__))), 'lib')
if os.path.exists(libdir):
    sys.path.append(libdir)

import logging
from waveshare_EMC2301 import waveshare_EMC2301
#Waveshare_EMC2301


logging.basicConfig(level=logging.INFO)

mod = waveshare_EMC2301
obj = waveshare_EMC2301.EMC2301()

try:
    product_ID = obj.Read_Byte(mod.PRODUCT_ID)
    Manufacturer_ID = obj.Read_Byte(mod.MANUFACTURER_ID)
    print('ID_value : 0x%x\r\n'%product_ID)
    print('Manufacturer_ID : 0x%x\r\n'%Manufacturer_ID)
    if(product_ID == 0x37 and Manufacturer_ID==0x5D):
        print('I2C OK !\r\n')
     
    
        obj.EMC2301_setSpinUpDrive(60)
        obj.EMC2301_setSpinUpTime(300)#speed up time
        obj.EMC2301_setDriveUpdatePeriod(100)
        obj.EMC2301_RPMEnable()
        
        obj.EMC2301_writeTachoTarget(8192)
        for i in range(0,10):
            obj.EMC2301_fetchFanSpeed()
            time.sleep(0.5)
        obj.EMC2301_writeTachoTarget(32)           
        for i in range(0,10):
            obj.EMC2301_fetchFanSpeed()
            time.sleep(0.5)
        obj.EMC2301_writeTachoTarget(500)           
        for i in range(0,10):
            obj.EMC2301_fetchFanSpeed()
            time.sleep(0.5)
        obj.EMC2301_writeTachoTarget(1000)           
        for i in range(0,10):
            obj.EMC2301_fetchFanSpeed()
            time.sleep(0.5)   
        obj.EMC2301_writeTachoTarget(5000)           
        for i in range(0,10):
            obj.EMC2301_fetchFanSpeed()
            time.sleep(0.5)   
        obj.EMC2301_writeTachoTarget(8192)           
        for i in range(0,10):
            obj.EMC2301_fetchFanSpeed()
            time.sleep(0.5) 
        obj.EMC2301_writeTachoTarget(32)           
        for i in range(0,10):
            obj.EMC2301_fetchFanSpeed()
            time.sleep(0.5)
        obj.EMC2301_writeTachoTarget(0)           
        for i in range(0,10):
            obj.EMC2301_fetchFanSpeed()
            time.sleep(0.5)              
        
        
        ###Comment the code above, uncomment the code below, means direct control of the wind speed.
        '''
        obj.EMC2301_Directspeedcontrol(30)
        for i in range(0,12):
            obj.EMC2301_fetchFanSpeed()
            time.sleep(0.5)
        '''
         
    else:
        print('I2C Error !\r\n')
    
except KeyboardInterrupt:    
    logging.info('ctrl + c:')
    exit()

